#include <stdlib.h>
#include <stdio.h>
#include <time.h> // for random

//#define AVG2(x,y) ( (x >> 1) + (y >> 1) )
//#define AVG4(a,b,c,d) ( (a >> 2) + (b >> 2) + (c >> 2) + (d >> 2) )

#define AVG2(x,y) (unsigned char) ( ((int)x + (int)y) / 2)
#define AVG4(a,b,c,d) (unsigned char) ( ((int)a + (int)b + (int)c + (int)d) / 4)



/**
 * Moderately fast and proper bayer to rgb conversion
 *
 * @param rgb - the rgb surface
 * @param bayer - the bayer surface
 * @param height - image height
 * @param width - image width
 *
 * @author Martin
 */
void bayer_to_rgb(unsigned char *rgb, const unsigned char *bayer, const int height, const int width) {
	int x,y;

	// blit out initial data
	for(y = 0; y < height; y++) {
		for( x = 0 ; x < width; x++) {
			if( y&1 ) {
				/* GBGBGB line */
				if(x&1) { // blue
					rgb[y * width * 3 + x*3 + 2] = bayer[y * width + x];	
				} else { // green
					rgb[y * width * 3 + x*3 + 1] = bayer[y * width + x];
				}
	
			} else {
				/*RGRGRG line */
				if(x&1) { // green
					rgb[y * width * 3 + x*3 + 1] = bayer[y * width + x];	
				} else { // red
					rgb[y * width * 3 + x*3 + 0] = bayer[y * width + x];
				}	
			}
		}
	}

	
	// interpolation steps
	
	int cpos; // current pos
	int ltpos; // line on top of us pos
	int lbpos; // line below of us pos

	// blit in everything but the borders
	for(y = 1; y < (height - 1); y++) {
		if( y&1 ) {
			/*GBGBGB line */
			for( x = 1; x < (width - 1); x++) {
				cpos = y*width + x;
				ltpos = cpos - width;
				lbpos = cpos + width;
				
				if( x&1 ) { // blue is known
					// calculate red
					rgb[(cpos)*3 + 0] = AVG4( \
						/*Rtl*/ bayer[ltpos - 1], \
						/*Rtr*/ bayer[ltpos +1], \
						/*Rbl*/ bayer[lbpos -1], \
						/*Rbr*/ bayer[lbpos +1] \
					);
					// calculate green
					rgb[(cpos)*3 + 1] = AVG4( \
						/*Gt*/ bayer[ltpos], \
						/*Gl*/ bayer[cpos-1], \
						/*Gb*/ bayer[lbpos], \
						/*Gr*/ bayer[cpos+1] \
					);
	
				} else { // green is known
					// calculate red 
					rgb[(cpos)*3 + 0] = AVG2( \
						/*Rt*/ bayer[ltpos], \
						/*Rb*/ bayer[lbpos] \
					);
					// calculate blue
					rgb[(cpos)*3 + 2] = AVG2( \
						/*Bl*/ bayer[cpos-1], \
						/*Br*/ bayer[cpos+1] \
					);
				}
			}
		} else {
			/* RGRG line */
			for( x = 1; x < (width - 1); x++) {
				cpos = y*width + x;
				ltpos = cpos - width;
				lbpos = cpos + width;
	
				if( x&1 ) { // green is known
					// calculate red 
					rgb[(cpos)*3 + 0] = AVG2( \
						/*Rl*/ bayer[cpos-1], \
						/*Rr*/ bayer[cpos+1] \
					);
					// calculate blue
					rgb[(cpos)*3 + 2] = AVG2( \
						/*Bt*/ bayer[ltpos], \
						/*Bb*/ bayer[lbpos] \
					);
	
				} else { // red is known
					// calculate blue
					rgb[(cpos)*3 + 2] = AVG4( \
						/*Rtl*/ bayer[ltpos - 1], \
						/*Rtr*/ bayer[ltpos + 1], \
						/*Rbl*/ bayer[lbpos - 1], \
						/*Rbr*/ bayer[lbpos + 1] \
					);
					// calculate green
					rgb[(cpos)*3 + 1] = AVG4( \
						/*Gt*/ bayer[ltpos], \
						/*Gl*/ bayer[cpos-1], \
						/*Gb*/ bayer[lbpos], \
						/*Gr*/ bayer[cpos+1] \
					);
				}
			}		
		}
	}	
}


void read_bayer(char *filename, int skype, unsigned char *bayer, int height, int width)
{
	int i;
	FILE *fp;
	int x,y;
	fp = fopen(filename, "rb");

	for (i=0; i<skype; i++)
		fgetc(fp);

	for(y = 0; y < height; y++) {
		for( x = 0 ; x < width; x++) {
			bayer[y * width + x] = (unsigned char) fgetc(fp);
		}
	}

	fclose(fp);
}


void random_bayer(unsigned char *bayer, int height, int width) {
	int x,y;
	srandom((unsigned int) time(NULL));
	for(y = 0; y < height; y++) {
		for( x = 0 ; x < width; x++) {
			bayer[y * width + x] = 16 + (unsigned char) random() % 240;
		}
	}
}


void hexdump(unsigned char *data, int height, int width, int mode) {
	int x,y;
	unsigned int r = 0, g = 0, b = 0;
	FILE *fp;
	char *ppmheader = "P6\n# Generated by yuv2ppm\n640 480\n255\n";

	printf("Hexdump\n");

	fp = fopen("out.ppm", "wb+");
	fprintf(fp, ppmheader);


	for(y = 0; y < height; y++) {
		for( x = 0 ; x < width; x++) {
			// printf("\n %d %d \n", x , y);
			if (mode > 1) {
				r = data[y*width*3 + x*3];
				g = data[y*width*3 + x*3 + 1];
				b = data[y*width*3 + x*3 + 2]; 

				fwrite(&r, 1, 1, fp);
				fwrite(&g, 1, 1, fp);
				fwrite(&b, 1, 1, fp);
			}
			else if(mode >= 0) { // show 3 byte blocks [rgb]
				r = data[y*width*3 + x*3];
				g = data[y*width*3 + x*3 + 1];
				b = data[y*width*3 + x*3 + 2]; 
				printf("[%02x %02x %02x] ", r, g, b);
			} else { // show 1 by 1 [bayer]
				printf("%02x ", data[y*width + x]);
			}
		}
		if (mode <= 1)
			printf("\n");
	}
		if (mode <= 1)
	printf( "\n" );	

	fclose(fp);
}

#define TESTW 640
#define TESTH 480

//#define TESTW 6
//#define TESTH 6


int main(int argc, char *argv[]) {
	unsigned char *rgb;
	unsigned char *bayer;
	bayer = calloc(TESTW * TESTH , sizeof(char));
	rgb = calloc(3 * TESTW * TESTH , sizeof(char));

	
 	if (argc > 1)
		read_bayer(argv[1], atoi(argv[2]), bayer, TESTH, TESTW);
	else {
		random_bayer(bayer, TESTH, TESTW);
		hexdump(bayer,TESTH,TESTW,-1);
	}

	int i;
	for(i=0; i < 100 ; i++) {
		bayer_to_rgb(rgb,bayer,TESTH,TESTW);
	}
	
	if (argc> 1)
		hexdump(rgb,TESTH,TESTW,2);
	else
		hexdump(rgb,TESTH,TESTW,1);


	return 0;
}
